# (c) 2008 by Ralf Ertzinger <ralf@camperquake.de>
# licensed under GNU GPL v2
#
# Grabber for snotr.com

package videosite::SnotrGrabber;

use videosite::GrabberBase;
@ISA = qw(videosite::GrabberBase);

use videosite::HTMLHelper;
use Data::Dumper;

use strict;

sub new {
    my $class = shift;
    my $self = $class->SUPER::new(
        NAME => 'snotr',
        _SELFTESTURL => 'http://www.snotr.com/video/1836',
        _SELFTESTTITLE => 'Brilliant thief',
        PATTERNS => ['(http://(?:[-a-zA-Z0-9_.]+\.)*snotr\.com/video/(\d+))'],
        @_,
    );

    return bless($self, $class);
}

sub _parse {
    my $self = shift;
    my $url = shift;
    my $pattern = shift;
    my $content;
    my $metadata = {};
    my $p = videosite::HTMLHelper->new();
    my $n;

    $url =~ m|$pattern|;
    $url = $1;

    $metadata->{'URL'} = $url;
    $metadata->{'ID'} = $2;
    $metadata->{'TYPE'} = 'video';
    $metadata->{'SOURCE'} = $self->{'NAME'};
    $metadata->{'TITLE'} = undef;
    $metadata->{'DLURL'} = undef;

    # Get the HTML file containing the title
    unless(defined($p->load(sprintf('http://www.snotr.com/video/%s', $2)))) {
        $self->error('Could not download HTML');
        return undef;
    }

    $n = $p->findnodes('meta[@property="og:title"]');
    if (defined($n)) {
        $metadata->{'TITLE'} = $n->{'content'};
    }

    # The actual video URL is insultingly simple.
    $metadata->{'DLURL'} = sprintf('http://videos.snotr.com/%s.flv', $metadata->{'ID'});

    unless(defined($metadata->{'DLURL'}) && defined($metadata->{'TITLE'})) {
        $self->error('Could not extract download URL and title');
        return undef;
    }

    return $metadata;
}

1;
